diff --git a/tests/Feature/Http/Controllers/UsersControllerTest.php b/tests/Feature/Http/Controllers/UsersControllerTest.php
new file mode 100644
index 0000000..d6e5eac
--- /dev/null
+++ b/tests/Feature/Http/Controllers/UsersControllerTest.php
@@ -0,0 +1,486 @@
+<?php
+
+namespace Tests\Feature\Http\Controllers;
+
+use Authy;
+use Hash;
+use Input;
+use Settings;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Events\User\TwoFactorEnabledByAdmin;
+use Portal\Events\User\UpdatedByAdmin;
+use Portal\Role;
+use Portal\Support\Enum\UserStatus;
+use Portal\User;
+use Carbon\Carbon;
+use Mockery as m;
+
+class UsersControllerTest extends FunctionalTestCase
+{
+
+    public function test_users_table_is_displayed()
+    {
+        $this->be($this->makeSuperUser());
+
+        $active = factory(User::class)->times(4)->create();
+        $banned = factory(User::class)->times(2)->create(['status' => UserStatus::BANNED]);
+        $unconfirmed = factory(User::class)->times(2)->create(['status' => UserStatus::UNCONFIRMED]);
+
+        $users = $active->merge($banned);
+        $users = $users->merge($unconfirmed);
+
+        $users = $users->reverse();
+
+        $this->visit('user')
+            ->seeInElement("h1.page-header", "Users")
+            ->seeInElement('h1.page-header small', 'list of registered users')
+            ->seeElement("#add-user");
+
+        foreach ($users as $i => $user) {
+            $this->seeInTable("#users-table-wrapper table", $user->present()->username, $i + 1, 1);
+            $this->seeInTable("#users-table-wrapper table", $user->present()->name, $i + 1, 2);
+            $this->seeInTable("#users-table-wrapper table", $user->email, $i + 1, 3);
+            $this->seeInTable("#users-table-wrapper table", $user->created_at->format('Y-m-d'), $i + 1, 4);
+            $this->seeInTable("#users-table-wrapper table", $user->status, $i + 1, 5);
+        }
+    }
+
+    public function test_users_pagination()
+    {
+        $this->be($this->makeSuperUser());
+
+        factory(User::class)->times(21)->create();
+
+        $this->visit('user');
+
+        $pagination = $this->crawler->filter(".pagination");
+        $paginationLinks = $this->crawler->filter('.pagination a');
+
+        $this->assertEquals(1, $pagination->count());
+        $this->assertEquals(2, $paginationLinks->count());
+    }
+
+    public function test_users_search()
+    {
+        $user1 = factory(User::class)->create(['first_name' => 'Milos', 'last_name' => 'Stojanovic']);
+        $user2 = factory(User::class)->create(['first_name' => 'John', 'last_name' => 'Doe']);
+        $user3 = factory(User::class)->create(['first_name' => 'Jane', 'last_name' => 'Doe']);
+
+        $this->be($this->makeSuperUser($user1));
+
+        $this->visit('user')
+            ->submitForm('search-users-btn', ['search' => 'doe'])
+            ->seePageIs('user?search=doe&status=')
+            ->seeInField('search', 'doe')
+            ->seeInTable('table', $user2->present()->name, 1, 2)
+            ->seeInTable('table', $user3->present()->name, 2, 2);
+    }
+
+    public function test_users_filter_by_status()
+    {
+        $this->be($this->makeSuperUser());
+
+        factory(User::class)->times(2)->create();
+        factory(User::class)->times(3)->create();
+
+        $this->visit('user?status=' . UserStatus::BANNED)
+            ->seeIsSelected('status', UserStatus::BANNED);
+
+        $this->assertEquals(1, $this->crawler->filter('#users-table-wrapper table tbody tr')->count());
+    }
+
+    public function test_add_user()
+    {
+        $this->beSuperUser();
+
+        $this->visit('user')
+            ->click('Add User')
+            ->seePageIs('user/create');
+
+        $data = $this->stubUserData();
+
+        $this->submitForm('Create User', $data);
+
+        $user = User::where('email', $data['email'])->first();
+
+        $expected = array_except($data, ['role', 'password', 'password_confirmation']);
+
+        $this->seeInDatabase('users', $expected)
+            ->seePageIs('user')
+            ->see('User created successfully.')
+            ->assertTrue(Hash::check('123123', $user->password));
+    }
+
+    public function test_add_user_without_country()
+    {
+        $this->beSuperUser();
+
+        $this->visit('user')
+            ->click('Add User')
+            ->seePageIs('user/create');
+
+        $data = $this->stubUserData();
+        $data['country_id'] = 0;
+
+        $this->submitForm('Create User', $data);
+
+        $user = User::where('email', $data['email'])->first();
+
+        $expected = array_except($data, ['role', 'password', 'password_confirmation']);
+        $expected['country_id'] = null;
+
+        $this->seeInDatabase('users', $expected)
+            ->seePageIs('user')
+            ->see('User created successfully.')
+            ->assertTrue(Hash::check('123123', $user->password));
+    }
+
+    public function test_add_user_validation()
+    {
+        $this->beSuperUser();
+
+        $this->visit('user/create')
+            ->press('Create User')
+            ->seePageIs('user/create')
+            ->see('The email field is required.')
+            ->see('The password field is required.');
+
+        $this->visit('user/create')
+            ->type('asdfa', 'email')
+            ->type('123', 'password')
+            ->type('122', 'password_confirmation')
+            ->press('Create User')
+            ->seePageIs('user/create')
+            ->see('The email must be a valid email address.')
+            ->see('The password must be at least 6 characters.')
+            ->see('The password confirmation does not match.');
+    }
+
+    public function test_view_user_page()
+    {
+        $user = $this->createAndLoginAdminUser();
+
+        $this->visit('user')
+            ->clickOn('a[title="View User"]')
+            ->seePageIs("user/{$user->id}/show")
+            ->seeLink('Edit', route('user.edit', $user->id));
+    }
+
+    public function test_update_user_details()
+    {
+        $this->expectsEvents(UpdatedByAdmin::class);
+
+        $this->createAndLoginAdminUser();
+
+        $user = $this->createUserWithSocialNetworks();
+        $user = $this->setRoleForUser($user, 'User');
+
+        $this->visit('user')
+            ->seeLink('', "user/{$user->id}/edit");
+
+        $this->visit("user/{$user->id}/edit");
+
+        $data = [
+            'role' => Role::whereName('User')->first()->id,
+            'status' => UserStatus::BANNED,
+            'first_name' => 'foo',
+            'last_name' => 'bar',
+            'birthday' => Carbon::now()->subYears(25)->format('Y-m-d'),
+            'phone' => '12345667',
+            'address' => 'the address',
+            'country_id' => 688 //Serbia,
+        ];
+
+        $this->submitForm('update-details-btn', $data);
+
+        $expected = array_except($data, 'role') + ['id' => $user->id];
+
+        $this->seeInDatabase('users', $expected)
+            ->seeInDatabase('role_user', ['user_id' => $user->id, 'role_id' => $data['role']])
+            ->seePageIs("user/{$user->id}/edit")
+            ->see('User updated successfully.');
+    }
+
+    public function test_update_user_social_networks()
+    {
+        $user = $this->createAndLoginAdminUser();
+
+        $data = [
+            'facebook' => 'facebook',
+            'twitter' => 'twitter',
+            'google_plus' => 'g+',
+            'linked_in' => 'li',
+            'dribbble' => 'Dribble',
+            'skype' => 'skyyype'
+        ];
+
+        $this->visit("user/{$user->id}/edit")
+            ->submitForm('Update Social Networks', ['socials' => $data])
+            ->seeInDatabase('user_social_networks', $data)
+            ->seePageIs("user/{$user->id}/edit")
+            ->see("Social networks updated successfully.");
+    }
+
+    public function test_update_user_login_details()
+    {
+        $user = $this->createAndLoginAdminUser([
+            'email' => 'test@test.com',
+            'username' => 'test',
+            'password' => 'milos123'
+        ]);
+
+        $data = [
+            'email' => 'john@doe.com',
+            'username' => 'milos',
+            'password' => '123123',
+            'password_confirmation' => '123123'
+        ];
+
+        $this->visit("user/{$user->id}/edit")
+            ->submitForm("update-login-details-btn", $data)
+            ->seePageIs("user/{$user->id}/edit")
+            ->see('Login details updated successfully.');
+
+        $user = $user->fresh();
+
+        $this->assertEquals($data['email'], $user->email);
+        $this->assertEquals($data['username'], $user->username);
+        $this->assertTrue(Hash::check($data['password'], $user->password));
+    }
+
+    public function test_2fa_form_visibility()
+    {
+        Settings::set('2fa.enabled', false);
+        $user = $this->createAndLoginAdminUser();
+
+        $this->visit("user/{$user->id}/edit")
+            ->dontSee('Two-Factor Authentication');
+
+        Settings::set('2fa.enabled', true);
+
+        $this->visit("user/{$user->id}/edit")
+            ->see('Two-Factor Authentication');
+    }
+
+    public function test_enable_2fa_for_user()
+    {
+        $this->expectsEvents(TwoFactorEnabledByAdmin::class);
+
+        Settings::set('2fa.enabled', true);
+        $user = $this->createAndLoginAdminUser();
+
+        Authy::shouldReceive('isEnabled')->andReturn(false);
+        Authy::shouldReceive('register')->andReturnNull();
+
+        $data = ['country_code' => '1', 'phone_number' => '123'];
+
+        $this->visit("user/{$user->id}/edit")
+            ->submitForm('Enable', $data)
+            ->seePageIs("user/{$user->id}/edit")
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => $data['country_code'],
+                'two_factor_phone' => $data['phone_number']
+            ])
+            ->see('Two-Factor Authentication enabled successfully.');
+    }
+
+    public function test_disable_2fa_for_user()
+    {
+        $this->expectsEvents(\Portal\Events\User\TwoFactorDisabledByAdmin::class);
+
+        Settings::set('2fa.enabled', true);
+        $user = $this->createAndLoginAdminUser();
+
+        Authy::shouldReceive('isEnabled')->andReturn(true);
+        Authy::shouldReceive('delete')->andReturnNull();
+
+        $this->visit("user/{$user->id}/edit")
+            ->press('Disable')
+            ->seePageIs("user/{$user->id}/edit")
+            ->seeInDatabase('users', [
+                'id' => $user->id,
+                'two_factor_country_code' => null,
+                'two_factor_phone' => null
+            ])
+            ->see('Two-Factor Authentication disabled successfully.');
+    }
+
+    public function test_avatar_update()
+    {
+        $user = $this->createAndLoginAdminUser();
+
+        $uploads = ['avatar' => base_path('tests/files/image.png')];
+
+        $input = [
+            'points' => [
+                'x1' => 0,
+                'y1' => 0,
+                'x2' => 200,
+                'y2' => 200
+            ]
+        ] + $uploads;
+
+        $this->visit("user/{$user->id}/edit")
+            ->submitForm('Save', $input, $uploads);
+
+        $this->seePageIs("user/{$user->id}/edit")
+            ->see('Avatar changed successfully.');
+
+        $user = $user->fresh();
+
+        $uploadedFile = public_path("upload/users/{$user->avatar}");
+
+        $this->assertNotNull($user->avatar);
+        $this->assertFileExists($uploadedFile);
+
+        list($width, $height) = getimagesize($uploadedFile);
+
+        $this->assertEquals(160, $width);
+        $this->assertEquals(160, $height);
+
+        @unlink($uploadedFile);
+    }
+
+    public function test_avatar_update_with_invalid_file()
+    {
+        $user = $this->createAndLoginAdminUser();
+
+        $file = storage_path("app/portal-test.php");
+
+        file_put_contents($file, "<?php ");
+
+        $uploads = ['avatar' => $file];
+
+        $input = [
+            'points' => [
+                'x1' => 0,
+                'y1' => 0,
+                'x2' => 200,
+                'y2' => 200
+            ]
+        ] + $uploads;
+
+        $this->visit("user/{$user->id}/edit")
+            ->submitForm('Save', $input, $uploads);
+
+        $this->seePageIs("user/{$user->id}/edit")
+            ->see("The avatar must be an image.");
+
+        $user = $user->fresh();
+
+        $this->assertNull($user->avatar);
+
+        @unlink($file);
+    }
+
+    /**
+     * @expectedException \Laravel\BrowserKitTesting\HttpException
+     */
+    public function test_session_page_is_not_available_for_non_database_driver()
+    {
+        putenv('SESSION_DRIVER=array');
+
+        $this->refreshApp();
+
+        $user = $this->createAndLoginAdminUser();
+
+        $this->visit('user')
+            ->dontSeeElement('a[title="User Sessions"]');
+
+        // this page should not be accessible if
+        // database session driver is not being used
+        $this->visit("user/{$user->id}/sessions");
+    }
+
+    public function test_invalidate_session()
+    {
+        putenv('SESSION_DRIVER=database');
+
+        $this->refreshApp();
+
+        Carbon::setTestNow(Carbon::now());
+
+        $user = $this->createAndLoginAdminUser();
+
+        $this->visit('user')
+            ->clickOn('a[title="User Sessions"]')
+            ->seePageIs("user/{$user->id}/sessions")
+            ->seeInTable('table', Input::ip(), 1, 1)
+            ->seeInTable('table', Input::header("User-agent"), 1, 2)
+            ->seeInTable('table', Carbon::now()->toDateString(), 1, 3);
+
+        $this->assertEquals(1, $this->crawler->filter("table tbody tr")->count());
+
+        $url = $this->crawler->filter('a[title="Invalidate Session"]')->first()->link()->getUri();
+
+        $this->delete($url)
+            ->followRedirects()
+            ->dontSeeInDatabase('sessions', ['user_id' => $user->id])
+            ->seePageIs("user/{$user->id}/sessions")
+            ->see('Session invalidated successfully.');
+    }
+
+    public function test_delete_user()
+    {
+        $this->createAndLoginAdminUser();
+
+        $user = $this->createUserWithSocialNetworks();
+        $user = $this->setRoleForUser($user, 'User');
+
+        $this->delete(route('user.delete', $user->id))
+            ->followRedirects()
+            ->seePageIs('user')
+            ->see("User deleted successfully.");
+    }
+
+    public function test_if_user_can_delete_himself()
+    {
+        $admin = $this->createAndLoginAdminUser();
+
+        $this->delete(route('user.delete', $admin->id))
+            ->followRedirects()
+            ->seePageIs('user')
+            ->see("You cannot delete yourself.");
+    }
+
+    /**
+     * @param array $override
+     * @return array
+     */
+    private function stubUserData(array $override = [])
+    {
+        return array_merge([
+            'role' => Role::where('name', 'User')->first()->id,
+            'status' => UserStatus::ACTIVE,
+            'first_name' => 'John',
+            'last_name' => 'Doe',
+            'birthday' => Carbon::now()->subYears(20)->format('Y-m-d'),
+            'phone' => '123456',
+            'address' => 'some address',
+            'country_id' => 688,
+            'email' => 'john@doe.com',
+            'username' => 'johndoe',
+            'password' => '123123',
+            'password_confirmation' => '123123'
+        ], $override);
+    }
+
+    private function beSuperUser()
+    {
+        $user = $this->createSuperUser();
+
+        $this->be($user);
+
+        return $user;
+    }
+
+    private function refreshApp()
+    {
+        $this->refreshApplication();
+
+        if ($this->isSQLiteConnection()) {
+            $this->executeCallbacks();
+        }
+    }
+}
diff --git a/tests/Feature/Listeners/BaseListenerTestCase.php b/tests/Feature/Listeners/BaseListenerTestCase.php
new file mode 100644
index 0000000..9f4a5cb
--- /dev/null
+++ b/tests/Feature/Listeners/BaseListenerTestCase.php
@@ -0,0 +1,29 @@
+<?php
+
+namespace Tests\Feature\Listeners;
+
+use Input;
+use Tests\Feature\FunctionalTestCase;
+use Portal\User;
+
+class BaseListenerTestCase extends FunctionalTestCase
+{
+    protected $user;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->user = factory(User::class)->create();
+        $this->be($this->user);
+    }
+
+    protected function assertMessageLogged($msg)
+    {
+        $this->seeInDatabase('user_activity', [
+            'user_id' => $this->user->id,
+            'ip_address' => Input::ip(),
+            'user_agent' => Input::header('User-agent'),
+            'description' => $msg
+        ]);
+    }
+}
\ No newline at end of file
diff --git a/tests/Feature/Listeners/PermissionEventsSubscriberTest.php b/tests/Feature/Listeners/PermissionEventsSubscriberTest.php
new file mode 100644
index 0000000..019289e
--- /dev/null
+++ b/tests/Feature/Listeners/PermissionEventsSubscriberTest.php
@@ -0,0 +1,38 @@
+<?php
+
+namespace Tests\Feature\Listeners;
+
+use Mockery as m;
+use Portal\Events\Permission\Created;
+use Portal\Events\Permission\Deleted;
+use Portal\Events\Permission\Updated;
+
+class PermissionEventsSubscriberTest extends BaseListenerTestCase
+{
+    protected $perm;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->perm = factory(\Portal\Permission::class)->create();
+    }
+
+    public function test_onCreate()
+    {
+        event(new Created($this->perm));
+        $this->assertMessageLogged("Created new permission called {$this->perm->display_name}.");
+    }
+
+    public function test_onUpdate()
+    {
+        event(new Updated($this->perm));
+        $this->assertMessageLogged("Updated the permission named {$this->perm->display_name}.");
+    }
+
+    public function test_onDelete()
+    {
+        event(new Deleted($this->perm));
+        $this->assertMessageLogged("Deleted permission named {$this->perm->display_name}.");
+    }
+
+}
diff --git a/tests/Feature/Listeners/RoleEventsSubscriberTest.php b/tests/Feature/Listeners/RoleEventsSubscriberTest.php
new file mode 100644
index 0000000..ff9a2d8
--- /dev/null
+++ b/tests/Feature/Listeners/RoleEventsSubscriberTest.php
@@ -0,0 +1,44 @@
+<?php
+
+namespace Tests\Feature\Listeners;
+
+use Portal\Events\Role\Created;
+use Portal\Events\Role\Deleted;
+use Portal\Events\Role\PermissionsUpdated;
+use Portal\Events\Role\Updated;
+
+class RoleEventsSubscriberTest extends BaseListenerTestCase
+{
+    protected $role;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->role = factory(\Portal\Role::class)->create();
+    }
+
+    public function test_onCreate()
+    {
+        event(new Created($this->role));
+        $this->assertMessageLogged("Created new role called {$this->role->display_name}.");
+    }
+
+    public function test_onUpdate()
+    {
+        event(new Updated($this->role));
+        $this->assertMessageLogged("Updated role with name {$this->role->display_name}.");
+    }
+
+    public function test_onDelete()
+    {
+        event(new Deleted($this->role));
+        $this->assertMessageLogged("Deleted role named {$this->role->display_name}.");
+    }
+
+    public function test_onPermissionsUpdate()
+    {
+        event(new PermissionsUpdated($this->role));
+        $this->assertMessageLogged("Updated role permissions.");
+    }
+
+}
diff --git a/tests/Feature/Listeners/UserEventsSubscriberTest.php b/tests/Feature/Listeners/UserEventsSubscriberTest.php
new file mode 100644
index 0000000..a968284
--- /dev/null
+++ b/tests/Feature/Listeners/UserEventsSubscriberTest.php
@@ -0,0 +1,148 @@
+<?php
+
+namespace Tests\Feature\Listeners;
+
+use Mockery as m;
+
+class UserEventsSubscriberTest extends BaseListenerTestCase
+{
+    protected $theUser;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->theUser = factory(\Portal\User::class)->create();
+    }
+
+    public function test_onLogin()
+    {
+        event(new \Portal\Events\User\LoggedIn);
+        $this->assertMessageLogged('Logged in.');
+    }
+
+    public function test_onLogout()
+    {
+        event(new \Portal\Events\User\LoggedOut());
+        $this->assertMessageLogged('Logged out.');
+    }
+
+    public function test_onRegister()
+    {
+        event(new \Portal\Events\User\Registered($this->user));
+        $this->assertMessageLogged('Created an account.');
+    }
+
+    public function test_onAvatarChange()
+    {
+        event(new \Portal\Events\User\ChangedAvatar);
+        $this->assertMessageLogged('Updated profile avatar.');
+    }
+
+    public function test_onProfileDetailsUpdate()
+    {
+        event(new \Portal\Events\User\UpdatedProfileDetails);
+        $this->assertMessageLogged('Updated profile details.');
+    }
+
+    public function test_onDelete()
+    {
+        event(new \Portal\Events\User\Deleted($this->theUser));
+
+        $message = sprintf(
+            "Deleted user %s.",
+            $this->theUser->present()->nameOrEmail
+        );
+
+        $this->assertMessageLogged($message);
+    }
+
+    public function test_onBan()
+    {
+        event(new \Portal\Events\User\Banned($this->theUser));
+
+        $message = sprintf(
+            "Banned user %s.",
+            $this->theUser->present()->nameOrEmail
+        );
+
+        $this->assertMessageLogged($message);
+    }
+
+    public function test_onUpdateByAdmin()
+    {
+        event(new \Portal\Events\User\UpdatedByAdmin($this->theUser));
+
+        $message = sprintf(
+            "Updated profile details for %s.",
+            $this->theUser->present()->nameOrEmail
+        );
+
+        $this->assertMessageLogged($message);
+    }
+
+    public function test_onCreate()
+    {
+        event(new \Portal\Events\User\Created($this->theUser));
+
+        $message = sprintf(
+            "Created an account for user %s.",
+            $this->theUser->present()->nameOrEmail
+        );
+
+        $this->assertMessageLogged($message);
+    }
+
+    public function test_onSettingsUpdate()
+    {
+        event(new \Portal\Events\Settings\Updated);
+        $this->assertMessageLogged('Updated website settings.');
+    }
+
+    public function test_onTwoFactorEnable()
+    {
+        event(new \Portal\Events\User\TwoFactorEnabled);
+        $this->assertMessageLogged('Enabled Two-Factor Authentication.');
+    }
+
+    public function test_onTwoFactorDisable()
+    {
+        event(new \Portal\Events\User\TwoFactorDisabled);
+        $this->assertMessageLogged('Disabled Two-Factor Authentication.');
+    }
+
+    public function test_onTwoFactorEnabledByAdmin()
+    {
+        event(new \Portal\Events\User\TwoFactorEnabledByAdmin($this->theUser));
+
+        $message = sprintf(
+            "Enabled Two-Factor Authentication for user %s.",
+            $this->theUser->present()->nameOrEmail
+        );
+
+        $this->assertMessageLogged($message);
+    }
+
+    public function test_onTwoFactorDisabledByAdmin()
+    {
+        event(new \Portal\Events\User\TwoFactorDisabledByAdmin($this->theUser));
+
+        $message = sprintf(
+            "Disabled Two-Factor Authentication for user %s.",
+            $this->theUser->present()->nameOrEmail
+        );
+
+        $this->assertMessageLogged($message);
+    }
+
+    public function test_onPasswordResetEmailRequest()
+    {
+        event(new \Portal\Events\User\RequestedPasswordResetEmail($this->user));
+        $this->assertMessageLogged("Requested password reset email.");
+    }
+
+    public function test_onPasswordReset()
+    {
+        event(new \Portal\Events\User\ResetedPasswordViaEmail($this->user));
+        $this->assertMessageLogged("Reseted password using \"Forgot Password\" option.");
+    }
+}
diff --git a/tests/Feature/Repositories/Activity/EloquentActivityTest.php b/tests/Feature/Repositories/Activity/EloquentActivityTest.php
new file mode 100644
index 0000000..748a42e
--- /dev/null
+++ b/tests/Feature/Repositories/Activity/EloquentActivityTest.php
@@ -0,0 +1,128 @@
+<?php
+
+namespace Tests\Feature\Repositories\Activity;
+
+use Tests\Feature\FunctionalTestCase;
+use Portal\Repositories\Activity\EloquentActivity;
+use Portal\Services\Logging\UserActivity\Activity;
+use Portal\User;
+use Carbon\Carbon;
+use Mockery as m;
+
+class EloquentActivityTest extends FunctionalTestCase
+{
+    /**
+     * @var EloquentActivity
+     */
+    protected $repo;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->repo = app(EloquentActivity::class);
+    }
+
+    public function test_log()
+    {
+        $user = factory(User::class)->create();
+
+        Carbon::setTestNow(Carbon::now());
+
+        $data = [
+            'user_id' => $user->id,
+            'ip_address' => '123.456.789.012',
+            'user_agent' => 'foo',
+            'description' => 'descriptionnnn'
+        ];
+
+        $this->repo->log($data);
+
+        $this->seeInDatabase('user_activity', $data);
+    }
+
+    public function test_paginateActivitiesForUser()
+    {
+        $user = factory(User::class)->create();
+
+        $activities = factory(Activity::class)->times(10)->make();
+        $user->activities()->saveMany($activities);
+
+        $result = $this->repo->paginateActivitiesForUser($user->id, 6)->toArray();
+
+        $this->assertEquals(6, count($result['data']));
+        $this->assertEquals(10, $result['total']);
+        $this->assertArraySubset($activities[0]->toArray(), $result['data'][0]);
+        $this->assertArraySubset($activities[5]->toArray(), $result['data'][5]);
+    }
+
+    public function test_getLatestActivitiesForUser()
+    {
+        $user = factory(User::class)->create();
+
+        Carbon::setTestNow(Carbon::now()->subDay());
+        $activities1 = factory(Activity::class)->times(5)->make();
+        $user->activities()->saveMany($activities1);
+
+        Carbon::setTestNow(null);
+        $activities2 = factory(Activity::class)->times(5)->make();
+        $user->activities()->saveMany($activities2);
+
+        $result = $this->repo->getLatestActivitiesForUser($user->id, 6)->toArray();
+
+        $this->assertEquals(6, count($result));
+        $this->assertArraySubset($activities2[0]->toArray(), $result[0]);
+        $this->assertArraySubset($activities1[0]->toArray(), $result[5]);
+    }
+
+    public function test_paginateActivities()
+    {
+        $activities = factory(Activity::class)->times(10)->create();
+
+        $result = $this->repo->paginateActivities(6)->toArray();
+
+        $this->assertEquals(6, count($result['data']));
+        $this->assertEquals(10, $result['total']);
+        $this->assertArraySubset($activities[0]->toArray(), $result['data'][0]);
+        $this->assertArraySubset($activities[5]->toArray(), $result['data'][5]);
+    }
+
+    public function test_userActivityForPeriod()
+    {
+        $user = factory(User::class)->create();
+        $now = Carbon::now();
+
+        Carbon::setTestNow($now->copy()->subDays(15));
+        factory(Activity::class)->times(5)->create(['user_id' => $user->id]);
+
+        Carbon::setTestNow($now->copy()->subDays(11));
+        factory(Activity::class)->times(2)->create(['user_id' => $user->id]);
+
+        Carbon::setTestNow($now->copy()->subDays(5));
+        factory(Activity::class)->times(3)->create(['user_id' => $user->id]);
+
+        Carbon::setTestNow($now->copy()->subDays(2));
+        factory(Activity::class)->times(2)->create(['user_id' => $user->id]);
+
+        Carbon::setTestNow(null);
+
+        $result = $this->repo->userActivityForPeriod(
+            $user->id, Carbon::now()->subWeeks(2), Carbon::now()
+        );
+
+        $this->assertEquals($result->get(Carbon::now()->subDays(14)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(13)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(12)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(11)->toDateString()), 2);
+        $this->assertEquals($result->get(Carbon::now()->subDays(10)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(9)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(8)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(7)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(6)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(5)->toDateString()), 3);
+        $this->assertEquals($result->get(Carbon::now()->subDays(4)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(3)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->subDays(2)->toDateString()), 2);
+        $this->assertEquals($result->get(Carbon::now()->subDays(1)->toDateString()), 0);
+        $this->assertEquals($result->get(Carbon::now()->toDateString()), 0);
+    }
+}
diff --git a/tests/Feature/Repositories/Country/EloquentCountryTest.php b/tests/Feature/Repositories/Country/EloquentCountryTest.php
new file mode 100644
index 0000000..a42bfdb
--- /dev/null
+++ b/tests/Feature/Repositories/Country/EloquentCountryTest.php
@@ -0,0 +1,34 @@
+<?php
+
+namespace Tests\Feature\Repositories\Country;
+
+use Mockery as m;
+use Tests\Feature\FunctionalTestCase;
+use Portal\Country;
+use Portal\Repositories\Country\EloquentCountry;
+
+class EloquentCountryTest extends FunctionalTestCase
+{
+    /**
+     * @var EloquentCountry
+     */
+    protected $repo;
+
+    protected $seed = false;
+
+    public function setUp()
+    {
+        parent::setUp();
+        $this->repo = app(EloquentCountry::class);
+    }
+
+    public function test_lists()
+    {
+        $countries = factory(Country::class)->times(8)->create();
+        $countries = $countries->sortBy(function ($country) {
+            return $country->name;
+        })->pluck('name', 'id');
+
+        $this->assertEquals($countries->toArray(), $this->repo->lists()->toArray());
+    }
+}
